#ifndef PPM_H
#define PPM_H

#include <stdio.h>

#include "point.h"

////////////////////
// Grafik-Zeugs

// Gre der Grafik in Pixel
#define PIX 200

// Die Grafik zeigt den Bereich mit Koordinaten
// von -SCALE bis SCALE. Was draussen liegt wird 
// abgeschnippelt
#define SCALE 1.25

// Verfgbare Farben
enum color
{
    CL_WHITE,
    CL_BLACK,
    CL_GREEN,
    CL_RED,
    CL_ROSE,
    CL_PINK,
    CL_BROWN,
    CL_CYAN,
    CL_LIME,
    CL_BLUE,
    CL_ORANGE,
    CL_YELLOW,
    
    CL_NIL
};

#define DPIX ((double) 2.0*SCALE/PIX)

extern int x2p (double x);
extern double p2x (int p);

extern void plot (int x, int y, unsigned int color);
extern void dot (p_t p, int color, int r);
extern void out_ppm (FILE*);
extern void ppm_clear (void);
extern void ppm_write (const char*,...);
extern void ppm_text (p_t, const char*, int);

#endif // PPM_H
