#ifndef SPLINE_H
#define SPLINE_H

#include <gsl/gsl_spline.h>

#include "point.h"
#include "ppm.h"
#include "lambda.h"

enum 
{
    INTERPOL_SPLINE,
    INTERPOL_LINEAR,
    
    INTERPOL_NIL
};

typedef struct
{
    // Anzahl Sttzpunkte-1
    unsigned int n;
    // Koordinaten 0..n
    double *x, *y;
    gsl_interp_accel *acc_x, *acc_y;
    gsl_spline *spline_x, *spline_y;
} spline_t;

extern p_t spline_eval (spline_t * s, double t);
extern spline_t * spline_alloc (unsigned int n, int interpol);
extern void spline_init (spline_t * s, lambda_t * l, double * x, double * y);
extern void spline_free (spline_t * s);
extern void spline_plot (spline_t * s, int color, unsigned int np);



#endif // SPLINE_H
