#if 0
#include "A-fft.h"
#include "B-fft.h"

    if (0)
    {
        kurve_ani_morph (A_fft, B_fft, "bild-%d.ppm", 100 /* frames */, 800 /* pix*/);
        exit (0);
    }
    
    if (0)
    {
        FILE * file = fopen ("data.c", "w");
        trafo_out_kurve_C (file, f, "data", l->t[l->n-1]);
        fclose (file);
    }

#endif

#if 0
static void qual_init (trafo_t * f)
{
    for (size_t k=0; k < f->n; k++)
    {
        double y = (double) k / f->n - 0.5;
        
        f->y[(k + f->n/2) % f->n] = y;
    }
}

#include <gsl/gsl_heapsort.h>
#include <gsl/gsl_fft_real.h>

int compare_abs (const void * da,
                 const void * db)
{
    double a = fabs (* ((const double*) da));
    double b = fabs (* ((const double*) db));
    
    if (a > b) return 1;
    if (a < b) return -1;
    
    return 0;
}

void qual (void)
{
    size_t k;
    fft_alloc (M);
    trafo_t * f = trafo_alloc (M);
    
    size_t * perm = (size_t*) calloc (M, sizeof (size_t));
    
    qual_init (f);
    trafo_plot_y (f, CL_BLACK);

    int thres = 32;
    //////////////////////////////////////////////////////////////////////
    // DWT
    trafo_dwt_xy (f);
    gsl_heapsort_index (perm, f->y, f->n, sizeof (double), compare_abs);
    
    for (k = 0; k < f->n -thres; k++)
        f->y[perm[k]] = 0.0;

    trafo_dwt_invert (f);
    trafo_plot_y (f, CL_RED);
    
    //////////////////////////////////////////////////////////////////////
    // FFT
    qual_init (f);
    
    gsl_fft_real_radix2_transform (f->y, 1, f->n);
    
    gsl_heapsort_index (perm, f->y, f->n, sizeof (double), compare_abs);
    
    for (k = 0; k < f->n -thres; k++)
        f->y[perm[k]] = 0.0;

    gsl_fft_halfcomplex_radix2_inverse (f->y, 1, f->n);
    trafo_plot_y (f, CL_GREEN);
    
    ppm_write ("bild-%d.ppm", ++fno);
    ppm_clear();
} 
#endif


#if 0
#include <gsl/gsl_multimin.h>

typedef struct 
{
    trafo_t * f;
    tupel_t * v;
    double * value;
    spline_t *s;
    lambda_t * l;
} params_t;

// This function should return the result f(x,params) for argument x 
// and parameters params. If the function cannot be computed, an 
// error value of GSL_NAN should be returned. 
static double my_f (const gsl_vector * x, void * params)
{
    params_t *p = (params_t*) params;
    
    memcpy (p->f->v, x->data, p->f->grad_dim * sizeof (double));
        
    return mumi_delta (p->f, p->v);
}

// This function should store the n-dimensional gradient 
// g_i = d f(x,params) / d x_i in the vector g for argument x 
// and parameters params, returning an appropriate error code 
// if the function cannot be computed. 
static void my_df (const gsl_vector * x, void * params, gsl_vector * g)
{
    params_t *p = (params_t*) params;
    
    memcpy (p->f->v, x->data, p->f->grad_dim * sizeof (double));
    
    mumi_eval_gradv (p->f, p->v);
    
    for (size_t k=0; k < p->f->grad_dim; k++)
        gsl_vector_set (g, k, k ? p->f->grad[k] : 0.0);
}
 
// This function should set the values of the f and g as above,
// for arguments x and parameters params. This function provides 
// an optimization of the separate functions for f(x) and g(x)
// -- it is always faster to compute the function and its derivative 
// at the same time.    
static void my_fdf (const gsl_vector * x, void * params, double * f, gsl_vector * g)
{
    *f = my_f (x, params);
    my_df (x, params, g);
}

int xmain (params_t * p)
{
    size_t iter = 0;
    int status;

    const gsl_multimin_fdfminimizer_type *T;
    gsl_multimin_fdfminimizer *s;

    gsl_vector *x, *min;
    gsl_multimin_function_fdf my_func;

    size_t dim = p->f->grad_dim;
    
    my_func.n = dim;
    my_func.f = &my_f;
    my_func.df = &my_df;
    my_func.fdf = &my_fdf;
    my_func.params = p;

    /* Starting point */
    x   = gsl_vector_alloc (dim);
    min = gsl_vector_alloc (dim);
    for (size_t k=0; k < dim; k++)
        gsl_vector_set (x, k, k ? p->f->v[k] : 0.0);
        
    T = gsl_multimin_fdfminimizer_vector_bfgs2;
    //T = gsl_multimin_fdfminimizer_steepest_descent;
    s = gsl_multimin_fdfminimizer_alloc (T, dim);

    gsl_multimin_fdfminimizer_set (s, &my_func, x, 0.001, 1e-4);

    do
    {
        iter++;
        status = gsl_multimin_fdfminimizer_iterate (s);

        if (status)
            break;

        status = gsl_multimin_test_gradient (s->gradient, 1e-3);

        if (status == GSL_SUCCESS)
            printf ("Minimum found at:\n");

        gsl_vector_memcpy (min, s->x);
        printf ("%5d  %10.5f\n", iter, s->f);

    }
    while (status == GSL_CONTINUE && iter < 100);

    memcpy (p->f->v, min->data, p->f->grad_dim * sizeof (double));
    
    gsl_multimin_fdfminimizer_free (s);
    gsl_vector_free (x);

    return 0;
}

// This function should store the n-dimensional gradient 
// g_i = d f(x,params) / d x_i in the vector g for argument x 
// and parameters params, returning an appropriate error code 
// if the function cannot be computed. 
static double my_f2_eval (params_t * p)
{
    spline_init (p->s, p->l, p->v->x, p->v->y);
    trafo_fft (p->f, p->s);

    double cost = 0.0;
    for (size_t k=1; k <= p->l->n; k++)
    {
        double c = p->l->t[k] - p->l->t[k-1];
        
        cost += 0.01/(c*c);
    }
        
    double d = bewerte_fft (p->f);
    printf ("Wert = % .7f, \t% .5f\n", d, cost);
    return d+cost;
}

static double my_f2 (const gsl_vector * x, void * params)
{
    params_t *p = (params_t*) params;
    
    memcpy (p->l->t, x->data, p->l->n * sizeof (double));
    p->l->t[0]       = 0.0;
    p->l->t[p->l->n] = 1.0;
        
    return my_f2_eval (p);
}

static void my_df2_grad (params_t * p, gsl_vector * g)
{
    double f0 = (p->value) ? * p->value : my_f2_eval (p);
    
    gsl_vector_set (g, 0, 0.0);
    for (size_t k=1; k < p->l->n; k++)
    {
        double eps = 1e-5;
        
        double tk = p->l->t[k];
        p->l->t[k] += eps;
        if (p->l->t[k] < p->l->t[k-1])
            error ("Position %d: % .5f < % .5f\n", k, p->l->t[k] , p->l->t[k-1]);
        double f1 = my_f2_eval (p);
        p->l->t[k] = tk;
        
        gsl_vector_set (g, k, (f1-f0) / eps);
    }
}

static void my_df2 (const gsl_vector * x, void * params, gsl_vector * g)
{
    params_t *p = (params_t*) params;
    memcpy (p->l->t, x->data, p->l->n * sizeof (double));
    p->l->t[0]       = 0.0;
    p->l->t[p->l->n] = 1.0;
    p->value = NULL;
    my_df2_grad (p, g);
}
 
static void my_fdf2 (const gsl_vector * x, void * params, double * f, gsl_vector * g)
{
    params_t *p = (params_t*) params;
    memcpy (p->l->t, x->data, p->l->n * sizeof (double));
    p->l->t[0]       = 0.0;
    p->l->t[p->l->n] = 1.0;
    
    *f = my_f2_eval (p);
    p->value = f;
    my_df2_grad (p, g);
}

int xmain_opt (params_t * p)
{
    size_t iter = 0;
    int status;

    const gsl_multimin_fdfminimizer_type *T;
    gsl_multimin_fdfminimizer *s;

    gsl_vector *x, *min;
    gsl_multimin_function_fdf my_func;

    size_t dim = p->l->n;
    
    my_func.n = dim;
    my_func.f = &my_f2;
    my_func.df = &my_df2;
    my_func.fdf = &my_fdf2;
    my_func.params = p;

    /* Starting point */
    x   = gsl_vector_alloc (dim);
    min = gsl_vector_alloc (dim);
    for (size_t k=0; k < dim; k++)
        gsl_vector_set (x, k, k ? p->l->t[k] : 0.0);
        
    T = gsl_multimin_fdfminimizer_vector_bfgs2;
    //T = gsl_multimin_fdfminimizer_steepest_descent;
    s = gsl_multimin_fdfminimizer_alloc (T, dim);

    gsl_multimin_fdfminimizer_set (s, &my_func, x, 0.00001, 1e-3);

    do
    {
        iter++;
        status = gsl_multimin_fdfminimizer_iterate (s);

        if (status)
            break;

        status = gsl_multimin_test_gradient (s->gradient, 1e-3);

        if (status == GSL_SUCCESS)
            printf ("Minimum found at:\n");

        gsl_vector_memcpy (min, s->x);
        printf ("%5d  %10.5f\n", iter, s->f);

    }
    while (status == GSL_CONTINUE && iter < 100);

    memcpy (p->l->t, min->data, p->l->n * sizeof (double));
    
    gsl_multimin_fdfminimizer_free (s);
    gsl_vector_free (x);

    return 0;
}
#endif

#if 0
    //////////////////////////////////////////////////////////////////////
    // BFGS Optimierung 
    if (0)
    {
        params_t params = { 
            .f = f,
            .v = v,
            .l = l,
            .s = s,
            .value = NULL
        };
        
        extern int xmain_opt (params_t*);
        xmain_opt (&params);
        
        for (size_t k=0; k <= l->n; k++)
        {
            printf ("t[%2d] = % .5f\n", k, l->t[k]);
        }
        
        spline_init (s, l, v->x, v->y);
        trafo_fft (f, s);
        trafo_crop (f, 0.06);
        trafo_plot (f, CL_GREEN, CL_YELLOW, 0.01, l->t[l->n-1]);
        tupel_plot (v, CL_RED, 4);
        ppm_write ("bild-bfgs-%d.ppm", ++fno);
        ppm_clear();
        
        plot_xy (f, l);
    }
#endif

#if 0
static p_t mumi_eval_v (trafo_t * f, double t);

// die FFT bewerten anhand des Abstands zu den
// Vorgabepunkten
// \sum_k |F(t_k)-P_k|
static double mumi_delta (trafo_t * f, tupel_t * v)
{
    double dist = 0.0;
    
    if (v->dim != f->num_p)
        error ("Falsches Tupel");
    
    for (unsigned int k=0; k < v->dim; k++)
    {
        p_t p = mumi_eval_v (f, f->v[k]);
        double delta = hypot (p.x - v->x[k], p.y - v->y[k]);
        //printf (" delta[%d] = % .5f\t%.3f,%.3f \t%.3f,%.3f\n", k, delta, p.x,v->x[k], p.y,v->y[k]);
        dist += delta*delta;
    }
        
    return dist;
}

static unsigned int mumi_dim (trafo_t * f, lambda_t * l)
{
    return l->n + 2*f->m[0]-1 + 2*f->m[1]-1;
}

static void mumi_alloc_v (trafo_t * f, lambda_t * l, tupel_t * v)
{
    if (v->dim != l->n)
        error ("v[%d] und l[%d] haben ungeleiche Dimension", v->dim, l->n);
            
    f->grad_dim = mumi_dim (f, l);
    f->grad = (double*) calloc (f->grad_dim, sizeof (double));
    f->v    = (double*) calloc (f->grad_dim, sizeof (double));
    f->num_p = l->n;
}

static void mumi_init_v (trafo_t * f, lambda_t * l)
{
    size_t dim = 0;
    double *c[] = { f->cx, f->cy };
    double * v = f->v;
    
    for (size_t k = 0; k < l->n; k++)
        *v++ = l->t[k], dim++;
    
    for (size_t i=0; i < 2; i++)
        for (size_t j=0; j < f->m[i]; j++)
        {
            p_t a_phi = to_a_phi (c[i], j, f->n);
        
            if (j == 0)
            {
                *v++ = a_phi.x * cos (a_phi.y);
                dim++;
                continue;
            }
            *v++ = a_phi.x;
            dim++;
            
            *v++ = a_phi.y;
            dim++;
        }
        
    if (dim != f->grad_dim)
        error ("Bser Fehler in Gradient-Dimension");
}

p_t mumi_eval_v (trafo_t * f, double t)
{
    t *= 2.0*M_PI;
    
    double x[2];
    double * pc[2] = 
    {
        f->v +  f->num_p, 
        f->v + (f->num_p + 2*f->m[0]-1) 
    };

    for (size_t i=0; i < 2; i++)
    {    
        x[i] = *pc[i]++;
        for (unsigned int k=1; k < f->m[i]; k++)
        {
            double A   = *pc[i]++;
            double phi = *pc[i]++;
            //printf ("%.5f * cos (%d + %.5f)\n", A, k, phi);
            x[i] += A * cos (t*k + phi);
        }
    }
    
    return (p_t) { x[0], x[1] };
}

// Ableitung nach t
p_t mumi_eval_dvdt (trafo_t * f, double t)
{
    t *= 2.0*M_PI;
    
    double x[2];
    double * pc[2] = 
    {
        f->v +  f->num_p, 
        f->v + (f->num_p + 2*f->m[0]-1) 
    };

    for (size_t i=0; i < 2; i++)
    {    
        pc[i]++;
        x[i] = 0.0;
        for (unsigned int k=1; k < f->m[i]; k++)
        {
            double A   = *pc[i]++;
            double phi = *pc[i]++;
            x[i] -= A * k * sin (t*k + phi);
        }
    }
    
    return (p_t) { 2.0*M_PI * x[0], 2.0*M_PI * x[1] };
}


static void mumi_eval_gradv (trafo_t * f, tupel_t * v)
{
    size_t dim = 0;
    
    double *p[] = { v->x,  v->y };
    
    double * grad = f->grad;
    
    for (size_t k=0; k < f->num_p; k++)
    {
        p_t  fk = mumi_eval_v    (f, f->v[k]);
        p_t dfk = mumi_eval_dvdt (f, f->v[k]);
            
        *grad++ = -2.0*(v->x[k] - fk.x) * dfk.x
                  -2.0*(v->y[k] - fk.y) * dfk.y;
        dim++;
    }
    
    for (size_t i=0; i < 2; i++)
        for (size_t j=0; j < f->m[i]; j++)
        {
            double *pA = f->v + f->num_p;
            if (i) pA += 2*f->m[0]-1;
            pA += 2*j-1;
            if (!j) pA++;
            
            double A   = *pA++;
            double phi = *pA;
            
            double g = 0.0;
        
            // A
            for (size_t k=0; k < v->dim; k++)
            {
                p_t fk = mumi_eval_v (f, f->v[k]);
                    
                double fki = (i==0) ? fk.x : fk.y;
                    
                if (j == 0)
                    g += -2.0*(p[i][k] - fki);
                else
                    g += -2.0*(p[i][k] - fki) * cos (2.0*M_PI*j * f->v[k] + phi);
            }
            
            *grad++ = g;
            dim++;
            
            if (j == 0)
                // phi_{i,0} = 0
                continue;
            g = 0;
            // phi
            for (size_t k=0; k < v->dim; k++)
            {
                p_t fk = mumi_eval_v (f, f->v[k]);
                    
                double fki = (i==0) ? fk.x : fk.y;
                    
                g += 2.0*(p[i][k] - fki) * A * sin (2.0*M_PI*j*f->v[k] + phi);
            }
        
            *grad++ = g;
            dim++;
        }
        
    if (dim != f->grad_dim)
        error ("Bser Fehler in Gradient-Dimension");
        
    if (f->num_p != v->dim)
        error ("Bser Fehler in Punktanzahl");
}

void mumi_plot (trafo_t * f, int color0, int color1, double step, double max_t)
{
    for (double t=0.0; t < 1.0; t += step)
        dot (mumi_eval_v (f, t), t < max_t ? color0 : color1, 1);
}

    if (0)
    {
        mumi_alloc_v (f, l, v);
        mumi_init_v  (f, l);
        
        trafo_t * fhelp = trafo_alloc (M);
        
        fhelp->n = f->n;
        fhelp->cx = f->cx;
        fhelp->cy = f->cy;
        fhelp->m[0] = f->m[0];
        fhelp->m[1] = f->m[1];
        
        mumi_alloc_v (fhelp, l, v);
        mumi_init_v  (fhelp, l);
    
        printf ("Dist0 = % .8f\n", mumi_delta (f, v));
        
        extern int xmain (params_t * p);
        
        params_t params = { .f = fhelp, .v = v };
        
        mumi_plot (f, CL_GREEN, CL_YELLOW, 0.0005, f->v[f->num_p-1]);
        tupel_plot (v, CL_RED, 4);
        ppm_write ("mumi-%d.ppm", ++fno);
        ppm_clear();
        
        xmain (&params);
      
        mumi_plot (fhelp, CL_GREEN, CL_YELLOW, 0.0005, fhelp->v[fhelp->num_p-1]);
        tupel_plot (v, CL_RED, 4);
        ppm_write ("mumi-%d.ppm", ++fno);
        ppm_clear();
    /*    
        for (size_t k=0; k<f->grad_dim; k++)
            printf ("v[%2d] = % .5f\n", k, f->v[k]);
    */        
        mumi_eval_gradv  (f, v);
        
        if(0)
        for (size_t k = 0; k < f->grad_dim; k++)
        {
            if (k == l->n || k == l->n + 2*f->m[0]-1)
                printf ("------------\n");
            
            //printf ("grad[%3d] = % .5f\t", k, *g++);
            
            if (k < l->n)
            {
                printf ("t_%2d\t", k);
            }
            else
            {
                unsigned int i, j = k - l->n;

                i = j >= 2*f->m[0]-1 ? 1 : 0;
                
                if (i) j -= 2*f->m[0]-1;
                if (j) j++;
                
                if (j % 2 == 0)
                    printf ("[%d,%d].A  \t", i, j/2);
                else
                    printf ("[%d,%d].phi\t", i, j/2);
                    
            }
            
            
            double eps = 0.0000001;
            double D1, D0 = mumi_delta (f, v);

            {
                double c = f->v[k];
                f->v[k] += eps;
                D1 = mumi_delta (f, v);
                f->v[k] = c;
            }

            double g = (D1-D0)/eps;
            
            printf (" grad[%2d] = % .5f  =? % .5f, \t% .8f\n", k, f->grad[k], g, f->grad[k]-g);
        }

        printf ("Ax0 = % .5f, Ay0 = % .5f\n", f->v[f->num_p], f->v[f->num_p + 2*f->m[0]-1]); 
        
        printf ("Dim(Grad) = %d\n", f->grad_dim);
    } // 0

#endif

#if 0
void trafo_plot_h (void)
{
    ppm_clear();
    for (double t=0.0; t < 2.0*M_PI; t += 0.0002)
    {
        p_t p;
        
        p.x = 12 * sin (t) -4 * sin(3*t);
        p.y = 13 * cos(t) -5 * cos(2*t) -2 * cos(3*t) - cos(4*t);
        p.x /= 16;
        p.y /= 16;
        dot (p, CL_BLACK, 3);
    }
    ppm_write ("herz-%d.ppm", ++fno);
    ppm_clear();
}
#endif




